Program SB16;

uses
 dos,crt;

Const
 Hexa:array[0..$F] of char='0123456789ABCDEF';

{.$define french}
{$ifdef french}
 Title=' Contrle du volume - SB16 (220h)';
 VolumeName:array[0..3] of PChar=('Volume gnral','Wave','MIDI','CD Audio');
 NotFound=#16' Carte SB16 non trouve';
 Right='Droit ';
 Left ='Gauche';
 SaveChange='Enregistrer les modifications (o/n) ?';
 Saved='Modifications effectues';
 kYES='O';
{$else}
 Title=' Volume Control - SB16 (220h)';
 VolumeName:array[0..3] of PChar=('General Volume','Wave','MIDI','CD Audio');
 NotFound=#16' SB16 Card not found';
 Right='Right ';
 Left ='Left  ';
 SaveChange='Save change (y/n) ?';
 Saved='Save done';
 kYES='Y';
{$endif}


 SB_PORT  =$0220;

 SB_RESET =SB_PORT+$0006;
 SB_STATUS=SB_PORT+$000E;
 SB_READ  =SB_PORT+$000A;

 SB_MIXER =SB_PORT+$0004;
 SB_DATA  =SB_MIXER+1;

 SB_VOLUME=$0030;

Var
 i:integer;
 VolumeInfo:array[0..7] of byte;
 VolumeData:array[0..7] of byte;

procedure error(msg:string);
 begin
  writeln(#16' ',msg);
  halt;
 end;

function reset:boolean;
 begin
  Port[SB_RESET]:=1;
  Delay (3);
  Port[SB_RESET]:=0;
  i:=1;
  Repeat
   inc(i);
   Repeat Until Port[SB_STATUS]>127;
  until (Port[SB_READ]=$AA)or(i=100);
  if i=100 then writeln(NotFound);
 end;

Procedure ReadInfo;
 begin
  for i:=0 to 7 do begin
   Port[SB_MIXER]:=SB_VOLUME+i;
   VolumeInfo[i] :=Port[SB_DATA] shr 3; { 0..31 }
   delay(3);
  end;
 end;

Procedure WriteInfo;
 begin
  for i:=0 to 7 do
   if VolumeData[i]<>VolumeInfo[i] then begin
    Port[SB_MIXER]:=SB_VOLUME+i;
    Port[SB_DATA] :=VolumeData[i] shl 3;
   end;
  WriteLn(Saved)
 end;

Procedure EndOfLine;
 var
  s:byte;
 begin
  for s:=WhereX to 48 do write(' ');
  TextAttr:=$07;
  Writeln;
 end;

procedure DrawJauge(value,color:integer);
 var
  x:byte;
 begin
  TextAttr:=color;
  for x:= 0 to Value do write('');
  TextAttr:=$70;
  for x:=value to 30 do write('');
 end;

procedure Jauge(index:integer);
 var
  value:byte;
 begin
  TextAttr:=$70; write('  ');
  if odd(index) then write(Right) else write(Left);
  write('  0 ');
  value:=VolumeData[index];
  DrawJauge(value,$7e);
  write(' 31');
  EndOfLine;
 end;

Function EditJauges:boolean;
 var
  j:integer;
  x,y:integer;
  jy:integer;
  v:integer;
  k:char;

  procedure up;
   begin
    if j>0 then begin
     VolumeData[j]:=v;
     gotoxy(13,jy);
     DrawJauge(v,$7E);
     dec(j);
     dec(jy); if odd(j) then dec(jy);
     v:=VolumeData[j];
    end;
   end;

  procedure down;
   begin
    if j<7 then begin
     VolumeData[j]:=v;
     gotoxy(13,jy);
     DrawJauge(v,$7E);
     inc(jy); if odd(j) then inc(jy);
     inc(j);
     v:=VolumeData[j];
    end;
   end;

 begin
  j:=0;
  x:=wherex;
  y:=wherey;
 jy:=y-12;
  v:=VolumeData[j];

  repeat

   gotoxy(13,jy);
   DrawJauge(v,$72);
   gotoxy(13+v,jy);

   k:=readkey; if k=#0 then k:=chr(128+ord(readkey));
   case k of
    #200: up;
    #203: if v>0  then dec(v);
    #205: if v<31 then inc(v);
    #208: down;
   end;

  until (k=#13)or(k=#27);

  VolumeData[j]:=v;

  gotoxy(x,y);
  TextAttr:=$07;

  EditJauges:=(k=#13);
 end;

Function Yes:boolean;
 var
  k:char;
 begin
  write(SaveChange);
  repeat
   k:=upcase(readkey);
  until k in [kYES,'N'];
  Yes:=(k=kYES);
  writeln;
 end;

procedure Display;
 var
  v:integer;
 begin
  TextAttr:=$70; Write(#14);
  TextAttr:=$1F; Write(Title); EndOfLine;

  for i:=0 to 7 do begin
   if not odd(i) then begin
    TextAttr:=$71;
    write(' ',VolumeName[i div 2]); EndOfLine;
   end;
   Jauge(i);
  end;

  TextAttr:=$31;
  Write(' (C) 1998 - Toth Paul <tothpaul@mygale.org>'); EndOfLine;
 end;

begin
 Reset;
 ReadInfo;
  Move(VolumeInfo,VolumeData,SizeOf(VolumeData));
  Display;
 if EditJauges or Yes then WriteInfo;
end.